#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <signal.h>
#include <termios.h>
#include <unistd.h>

#include <math.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <time.h>

#define MAIN_C
#include "exitfail.h"

#define SERIAL_BAUDRATE B115200
#define BUF_SIZE 2048

static int serial_fd = -1;
static struct termios old_tio;

static int terminated = 0;

#define BASENAME(p) ((strrchr((p), '/') ? : ((p) - 1)) +1)
#define ARRAY_SIZE(a) (sizeof(a) /sizeof((a)[0]))

#define __unused __attribute__((unused))

int main(void)
{
	FILE *fp;

//上から時間、温度、湿度、人感の状態、人感の回数、傾き
	char stra[25][50];
	char strb[25][50];
	char strc[25][50];

	char astr[25][30];
	char bstr[25][30];
	char cstr[25][30];
	char dstr[25][30];
	char estr[25][30];
	char fstr[25][30];

	int ret;
	int i, j;
	int row_max1,row_max2,row_max3;

/**** log read: begin ****/

	for(i = 0; i < 25; i++){
		for(j = 0; j < 50; j++){
			stra[i][j] = '\0';
			strb[i][j] = '\0';
			strc[i][j] = '\0';
		}
	}

	for(i = 0; i < 25; i++){
		for(j = 0; j < 30; j++){
			astr[i][j] = '\0';
			bstr[i][j] = '\0';
			cstr[i][j] = '\0';
			dstr[i][j] = '\0';
			estr[i][j] = '\0';
			fstr[i][j] = '\0';
		}
	}


	int chr;
	int flag;
	char ch[100];
	char *a;
	int len;
	char *word[100];
	const char *de = "&";
	int act = 0;
	int write_tmp = 0;
	int write_hum = 0;
	int write_acc = 0;

	const char s1[] = "tmp=act";
	const char s2[] = "hum=act";
	const char s3[] = "acc=act";
	const char s4[] = "write=tmp";
	const char s5[] = "write=hum";
	const char s6[] = "write=acc";

	char tmp[] = "./multi_tmp_read /dev/ttymxc0";
	char hum[] = "./multi_hum_read /dev/ttymxc0";
	char acc[] = "./multi_acc_read /dev/ttymxc0";

	char buf[1024];
	char *p;


	puts(
		"<Content-type: text/html>\n"
		"\n"
		"<HTML>\n"
		"<HEAD>\n"
		"<meta charset=\"UTF-8\">\n"
		"<TITLE> Armadillo-IoT </TITLE>\n"
		"</HEAD>\n"
		"<BODY>\n"
	);


//フォームからのデータ読み取り
	scanf("%s",ch);

	a=ch;
	for(len=0;len<100;len++){
		if((word[len]=strtok(a,de))==NULL)
			break;
		a=NULL;
	}
	for(i=0;i<len;i++){
			//puts(word[i]);
			if(strcmp(word[i],s1)==0){
				act = 1;
			}
			if(strcmp(word[i],s2)==0){
				act = 2;
			}
			if(strcmp(word[i],s3)==0){
				act = 3;
			}
			if(strcmp(word[i],s4)==0)
				write_tmp = 1;
			if(strcmp(word[i],s5)==0)
				write_hum = 1;
			if(strcmp(word[i],s6)==0)
				write_acc = 1;
	}

//クエリの送信
	switch(act){
		case 1:
			//puts("tmpsys");
			system(tmp);

			/*if((fp = popen(tmp, "r")) != NULL){
				while(fgets(buf, sizeof(buf), fp) != NULL){
					p = strchr(buf, '\n');
					if(p){
						*p = '\0';
					}
					puts(buf);
				}
				pclose(fp);
			}*/

			write_tmp = 1;
			break;
		case 2:
			//puts("humsys");
			system(hum);
			write_hum = 1;
			break;
		case 3:
			//puts("accsys");
			system(acc);
			write_acc = 1;
			break;
	}

//


	if(write_tmp==1){
//温湿度のテキストデータを変数に代入
	fp = fopen("/var/www/html/tmp.txt", "rt");

	if( fp == NULL ){
		puts( "cannot open /var/www/html/tmp.txt\n");
		return -1;
	}

	i = 0;

	fscanf( fp, "%s %s %s", stra[i], astr[i], bstr[i]);

	row_max1 = i;

	fclose(fp);

	}



	if(write_hum==1){
//人感のテキストデータを変数に代入
	fp = fopen("/var/www/html/hum.txt", "rt");

	if( fp == NULL ){
		puts( "cannot open /var/www/html/hum.txt\n");
		return -1;
	}

	i = 0;

	fscanf( fp, "%s %s %s", strb[i], cstr[i], dstr[i]);

	row_max2 = i;

	fclose(fp);

	}


	if(write_acc==1){
//加速度のテキストデータを変数に代入
	fp = fopen("/var/www/html/acc.txt", "rt");

	if( fp == NULL ){
		puts( "cannot open /var/www/html/acc.txt\n");
		return -1;
	}

	i = 0;

	fscanf( fp, "%s %s %s", strc[i], estr[i], fstr[i]);

	row_max3 = i;

	fclose(fp);


	}

	i = 0;


	puts("<form action=\"webcon.cgi\" method=\"post\">\n");

//温湿度表示
	puts("<button type=\"submit\" name=\"tmp\" value=\"act\">温湿度</button>\n");
	if(write_tmp==1){
		puts(stra[i]);
		puts(astr[i]);
		puts(bstr[i]);
		puts("<BR>");
		puts("<BR>");
		puts("<input type=\"hidden\" name=\"write\" value=\"tmp\">\n");
	}else{
		puts(
		  "年月日時分秒 温度:,湿度:"
		  "<BR>""<BR>"
		);
	}

//人感データ表示
	puts("<button type=\"submit\" name=\"hum\" value=\"act\">人感</button>\n");
	if(write_hum==1){
		puts(strb[i]);
		puts(cstr[i]);
		puts(dstr[i]);
		puts("<BR>");
		puts("<BR>");
		puts("<input type=\"hidden\" name=\"write\" value=\"hum\">\n");
	}else{
		puts(
		  "年月日時分秒 検知状態:,検知回数:"
		  "<BR>""<BR>"
		);
	}

//加速度データ表示
	puts("<button type=\"submit\" name=\"acc\" value=\"act\">傾き</button>\n");
	if(write_acc==1){
		puts(strc[i]);
		puts(estr[i]);
		puts(fstr[i]);
		puts("<BR>");
		puts("<input type=\"hidden\" name=\"write\" value=\"acc\">\n");
	}else{
		puts(
		  "年月日時分秒 傾き:"
		  "<BR>"
		);
	}
  
		  
		puts("</from>\n");


    puts(
        "</BODY>\n"
        "</HTML>"
    );
 
    return 0;
}
